const vscode = require('vscode');

class LingoDocumentSymbolProvider {
    provideDocumentSymbols(document, token) {
        return new Promise((resolve, reject) => {
            var symbols = [];
            for (var i = 0; i < document.lineCount; i++) {
                var line = document.lineAt(i);
                if (line.text.startsWith('on ')) {
                    symbols.push({
                        name: line.text.substring(3),
                        kind: vscode.SymbolKind.Function,
                        location: new vscode.Location(document.uri, line.range),
                        containerName: ''
                    });
                }
            }
            resolve(symbols);
        });
    }
}

/**
 * @param {vscode.ExtensionContext} context
 */
function activate(context) {
    context.subscriptions.push(vscode.languages.registerDocumentSymbolProvider({
    	language: 'lingo'
    },
    new LingoDocumentSymbolProvider()));
}

module.exports = {
	activate
}
